<?xml version='1.0' encoding='UTF-8' ?>
<!--
  ~ Copyright (c) 2016 Roman Nazarenko.
  ~
  ~  This program is free software: you can redistribute it and/or modify
  ~  it under the terms of the GNU Affero General Public License as
  ~  published by the Free Software Foundation, either version 3 of
  ~  the License, or (at your option) any later version.
  ~
  ~  This program is distributed in the hope that it will be useful,
  ~  but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~  GNU General Public License for more details.
  ~
  ~  You should have received a copy of the GNU General Public License
  ~  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	  xmlns:h="http://xmlns.jcp.org/jsf/html"
	  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	  xmlns:f="http://xmlns.jcp.org/jsf/core"
>

<h:head>
	<ui:include src="/WEB-INF/jsf/include/title.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/imports.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/init.xhtml"/>
</h:head>
<h:outputScript>

	$(function () {
		jsf.ajax.addOnEvent(function (event) {
			if (event.status === 'success') {
				registerMarkdownEditor();
				initializeDatePicker();
			}
		});
		registerMarkdownEditor();
		initializeDatePicker();
	});

	function registerMarkdownEditor() {
		$('#editArticleFormId\\:markdownTextArea').markdown({
			resize: 'vertical',
			height: 1200,
		});
	}

	function initializeDatePicker() {
		$('.date-picker-field').each(function () {
			var element = $(this);
			var value = element.attr('content');
			element.datepicker({
				showButtonPanel: true,
				dateFormat: 'mm/dd/yy',
			});
			if (value) {
				element.datepicker('setDate', value);
			}
		});
	}

</h:outputScript>
<h:body styleClass="pushable">
	<div class="pusher">
		<div class="ui container framed">
			<ui:include src="/WEB-INF/jsf/include/header.xhtml"/>

			<div class="ui centered two columns footer-margin grid">
				<div class="ui thirteen wide column">
					<div class="ui raised segment">
						<h2>Edit blog post</h2>
						<h:form id="editArticleFormId"
								styleClass="ui ${errorUtils.formClass(component)} form">
							<div class="ui centered two columns grid">
								<div class="ui row">
									<div class="ui twelve wide column">
										<div class="field">
											<label>Title</label>
											<h:inputText value="#{blogPostEditBean.get().title}"
														 validatorMessage="A title must be presented">
												<f:passThroughAttribute name="placeholder" value="Title"/>
												<f:validateRequired/>
											</h:inputText>
										</div>
										<div class="field">
											<label>Short title</label>
											<h:inputText value="#{blogPostEditBean.get().internalTitle}"
														 validatorMessage="A short title is invalid"
														 binding="#{blogPostEditBean.shortNameInput}">
												<f:passThroughAttribute name="placeholder" value="For navigation"/>
												<f:validateRequired/>
												<f:validateRegex pattern="[\-a-z\d]+"/>
											</h:inputText>
										</div>
										<div class="field">
											<div class="ui toggle checkbox">
												<h:selectBooleanCheckbox value="#{blogPostEditBean.get().published}"/>
												<label>Published</label>
											</div>
										</div>
										<div class="two fields">
											<div class="field">
												<label>Creation date</label>
												<h:inputText value="#{blogPostEditBean.creationDate}"
															 validatorMessage="A valid creation date is required"
															 styleClass="date-picker-field"
															 binding="#{blogPostEditBean.creationDateInput}">
													<f:validateRequired/>
												</h:inputText>
											</div>
											<div class="field">
												<label>Creation time</label>
												<h:inputText value="#{blogPostEditBean.creationTime}"
															 validatorMessage="A valid creation time is required"
															 binding="#{blogPostEditBean.creationTimeInput}">
													<f:validateRequired/>
												</h:inputText>
											</div>
										</div>
										<div class="field" onkeypress="triggerTagAdding(event)">
											<label>Tags</label>
											<h:selectManyMenu id="tagsDropdownId"
															  styleClass="ui fluid search dropdown"
															  value="#{blogPostEditBean.tags}">
												<f:selectItem itemValue="${null}" noSelectionOption="true"
															  itemLabel="Select tags"/>
												<f:selectItems value="${tagsBean.tags}" var="tag"
															   itemLabel="${tag.name}" itemValue="${tag.name}"/>
											</h:selectManyMenu>
										</div>
										<div class="ui success message">
											Changes successfully saved
										</div>
										<div class="ui error message">
											<div class="header">Error:</div>
											<h:messages showDetail="true" showSummary="false"/>
										</div>
									</div>
									<div class="ui four wide vertical middle aligned column">
										<div class="ui buttons">
											<h:commandButton styleClass="ui primary button"
															 value="Save"
															 action="#{blogPostEditBean.save}">
												<f:ajax execute="@form" render=":editArticleFormId"/>
											</h:commandButton>
											<div class="or"></div>
											<h:commandButton styleClass="ui secondary button"
															 value="Cancel"
															 action="#{blogPostEditBean.clear}">
												<f:ajax execute="@form" render=":editArticleFormId"/>
											</h:commandButton>
										</div>
									</div>
								</div>
								<div class="ui row">
									<div class="ui sixteen wide column">
										<div class="field">
											<label>Content</label>
											<h:inputTextarea id="markdownTextArea"
															 value="#{blogPostEditBean.content}"
															 hideLabel="true"
															 validatorMessage="Content must not be empty">
												<f:validateRequired/>
											</h:inputTextarea>
										</div>
									</div>
								</div>
							</div>
						</h:form>
					</div>
				</div>
			</div>
		</div>
		<ui:include src="/WEB-INF/jsf/include/footer.xhtml"/>
	</div>
</h:body>
</html>

